﻿#include "stdafx.h"
#include "CLIMultiThreadedSingleton.h"

using namespace System;
namespace $RootNamespace$
{

	$MultiThreadedSingleton$::$MultiThreadedSingleton$()
	{
	}

	void $MultiThreadedSingleton$::Operation()
	{
		Console::WriteLine("In $MultiThreadedSingleton$::Operation()");
	}

	$MultiThreadedSingleton$ ^$MultiThreadedSingleton$::Instance::get()
	{
		if (_instance == nullptr)
		{
			// 'lock' block is replaced by its C++ equivalent:
			System::Threading::Monitor::Enter(_syncRoot);
			try
			{
				if (_instance == nullptr)
					_instance = gcnew $MultiThreadedSingleton$();
			}
			finally
			{
				System::Threading::Monitor::Exit(_syncRoot);
			}
		}
	
		return _instance;
	}

	void $MultiThreadedSingleton$::Test()
	{
		$MultiThreadedSingleton$ ^singleton = $MultiThreadedSingleton$::Instance;
		singleton->Operation();
	
	}
}