﻿using System;

namespace $RootNamespace$
{

    public sealed class $MultiThreadedSingleton$
    {
        private static volatile $MultiThreadedSingleton$ _instance;
        private static object _syncRoot = new Object();

        private $MultiThreadedSingleton$() { }
	public void Operation() { Console.WriteLine("Operation of $MultiThreadedSingleton$"); }
        public static $MultiThreadedSingleton$ Instance
        {
            get
            {
                if (_instance == null)
                {
                    lock (_syncRoot)
                    {
                        if (_instance == null)
                            _instance = new $MultiThreadedSingleton$();
                    }
                }

                return _instance;
            }
        }

        public static void Test()
        {
            $MultiThreadedSingleton$ singleton = $MultiThreadedSingleton$.Instance;
            singleton.Operation();

        }

    }

}
