﻿Imports System

Namespace $RootNamespace$
     Public NotInheritable Class $MultiThreadedSingleton$
        ' Methods
        Private Sub New()
        End Sub

        Public Shared Sub Test()
            $MultiThreadedSingleton$.Instance.Operation()
        End Sub

        Public Sub Operation()
            Console.WriteLine("in $MultiThreadedSingleton$'s Operation()")
        End Sub


        ' Properties
        Public Shared ReadOnly Property Instance() As $MultiThreadedSingleton$
            Get
                If ($MultiThreadedSingleton$._instance Is Nothing) Then
                    SyncLock $MultiThreadedSingleton$._syncRoot
                        If ($MultiThreadedSingleton$._instance Is Nothing) Then
                            $MultiThreadedSingleton$._instance = New $MultiThreadedSingleton$
                        End If
                    End SyncLock
                End If
                Return $MultiThreadedSingleton$._instance
            End Get
        End Property


        ' Fields
    Private Shared _instance As $MultiThreadedSingleton$ 'ModReq(IsVolatile)
        Private Shared _syncRoot As Object = New Object
    End Class


End Namespace
